# XML语法

1.必须有根标签。例如<root>  </root>.语法嵌套在其中使用

2.头声明可有可无,但是建议写

<?xml version = "1.0" encoding = "utf-8"?>

![image-20210331120111837](XML与JSON学习笔记.assets/image-20210331120111837.png)

3.所有标签都必须成对

4.大小写敏感

5.标签不允许交叉

![image-20210331112032327](XML与JSON学习笔记.assets/image-20210331112032327.png)

6.XML的注释

<!-- -->

![image-20210331113015508](XML与JSON学习笔记.assets/image-20210331113015508.png)

7.特殊字符处理方法

XML实体中不允许出现"&","<",">"等特殊字符,否则XML语法检查时将出错,如果编写的XML文件必须包含这些字符,则必须分别写成"&amp;","&lt;","&gt;"再写入文件中。例如，如果在XML文档中使用类似"<" 的字符, 那么解析器将会出现错误，因为解析器会认为这是一个新元素的开始。所以不应该像下面那样书写代码：

```html
<age> age < 30 </age>
```

为了避免出现这种情况，必须将字符"<" 转换成实体，像下面这样：

<age> age &lt; 30 </age>

在读取的时候，解析器会自动将其转换回"&","<",">"等特殊字符，正常来说，只有"<" 字符和"&"字符对于XML来说是严格禁止使用的。
**需要注意的是：**
a. 转义序列各字符间不能有空格； 
b. 转义序列必须以"；"结束； 
c. 单独的&不被认为是转义开始； 
d. 区分大小写。

以下是XML中需要的转义字符:
![image-20210331125739692](XML与JSON学习笔记.assets/image-20210331125739692.png)

8.标签的属性

![image-20210331130722329](XML与JSON学习笔记.assets/image-20210331130722329.png)

①命名规则：字母数字下划线，但是数字不能开头

②属性内容必须用引号引起

③属性就是表示标签自身的一些额外信息

④XML中属性就是鸡肋（食之无肉，弃之有味），用得不多。

⑤解析XML数据时，属性会带来额外的解析代码（多了一步，比较麻烦）

9.CDATA

<![CDATA[......不用解析的内容......]]>

![image-20210331131354896](XML与JSON学习笔记.assets/image-20210331131354896.png)

**注意**：特殊字符较少时，使用实体替换，较多时使用CDATA,字母必须大写



# Json 语法

Json 是什么？
JSON(JavaScript Object Notation, JS 对象简谱) 是一种轻量级的数据交换格式。
它基于 ECMAScript (欧洲计算机协会制定的 js 规范)的一个子集， 采用完全独立于编程
语言的文本格式来存储和表示数据。
简洁和清晰的层次结构使得 JSON 成为理想的数据交换语言。
易于人阅读和编写， 同时也易于机器解析和生成， 并有效地提升网络传输效率。
JSON 其实就是一个独立于任何编程语言的独立的轻量的数据交换的东西， 方便于人的
阅读和机器的解析。
JSON 里面的内容还是键值对的形式存在的， 可以对其进行增删改查的， 但是当从数据
库中调用数据的时候， 需要对其进行数据的转换。

## **JSON 定义**

​     var json = {
​							键 : 值,
​							键 : 值,
​								.....
​						}
**说明 ：** json 中的键 用双引号括起来， 值可以是任意类型的数据
值可以是对象、 数组、 数字、 字符串或者三个字面值(false、 null、 true)中的一个。值中的字面值中的英文必须使用小写。



**对象**由花括号括起来的逗号分割的成员构成， 成员是字符串键和上文所述的值由逗号分割的键值对组成， 如：
{"name": "John",
"age": 18,
"address": {"country" : "china", "zip-code": "10000"}
} 

**数组**是由方括号括起来的一组值构成， 如：
[3, 1, 4, 1, 5, 9, 2, 6]

字符串与 C 或者 Java 的字符串非常相似。

**字符串**是由双引号包围的任意数量 Unicode 字符的集合， 使用反斜线转义。
一个字符（character） 即一个单独的字符串（character string） 。  